using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using System.Threading;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Text.RegularExpressions;

using Mobiquitous.Util;

namespace PhidgetHealth
{

	public class MainForm : System.Windows.Forms.Form
	{
		
		#region GUIR|[lg̐錾
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.TextBox textBoxId;
		private System.Windows.Forms.Label labelId;
		private System.Windows.Forms.Label labelRegistedId;
		private System.Windows.Forms.Button buttonRegister;
		private System.Windows.Forms.TabControl tabControl;
		private System.Windows.Forms.TabPage tabPageId;
		private System.Windows.Forms.StatusBar statusBar;
		private System.Windows.Forms.ListView listViewId;
		private System.Windows.Forms.ColumnHeader columnHeaderId;
		private System.Windows.Forms.ColumnHeader columnHeaderName;
		private System.Windows.Forms.TextBox textBoxMessage;
		private System.Windows.Forms.CheckBox checkBoxMessage;
		private System.Windows.Forms.TabPage tabPageDebug;
		private System.Windows.Forms.GroupBox groupBoxNet;
		private System.Windows.Forms.NumericUpDown numericUpDownPort;
		private System.Windows.Forms.Label labelPort;
		private System.Windows.Forms.Label labelIp;
		private System.Windows.Forms.TextBox textBoxIp;
		private System.Windows.Forms.Button buttonConnect;
		private System.Windows.Forms.Button buttonDisconnect;
		private System.Windows.Forms.TabPage tabPageWeight;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.ComboBox comboBoxUser;
		private System.Windows.Forms.NumericUpDown numericUpDownWeight;
		private System.Windows.Forms.TabPage tabPageSetting;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.GroupBox groupBox4;
		private System.Windows.Forms.NumericUpDown numericUpDownWeightConfirmTime;
		private System.Windows.Forms.NumericUpDown numericUpDownWeightConfirmError;
		private System.Windows.Forms.Button buttonHistoryGraph;
		private System.Windows.Forms.Button buttonHistoryList;
		private System.Windows.Forms.GroupBox groupBox5;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.NumericUpDown numericUpDownWeightReset;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.NumericUpDown numericUpDownOffset;
		#endregion

		#region ϐ/萔

		//eLXg{bNX̍ő\
		const int TEXTBOX_CNT_MAX = 10000;
		
		//Aǂݎp̃Xbh
		Thread rxThread = null;

		//^C}[p̃Xbh
		Thread timerThread = null;

		//APolling̃ftHgl(msec)
		const int RX_THREAD_INTERVAL = 100;
		
		//APolling̊Ԋu
		int rxThreadInterval = RX_THREAD_INTERVAL;

		//PhidgetServer֐ڑ邽߂TCP Client
		TcpClient phidgetClient = null;

		//PhidgetServerƂ̒ʐM^CAEg
		const int TIMEOUT_SERVER_RX = 1000;
		const int TIMEOUT_SERVER_TX = 1000;

		//ACeo^pHashtable
		Hashtable userHolder = new Hashtable();

		//ۑt@C
		const string USER_FILE = "users.txt";
		const string SETTING_FILE = "setting.txt";
		//؂q
		const string DELIMITER = "\t";

		//݂̑̏dl
		double currentWeight = 0.0;
	
		//̏do^tO
		bool weightRegistered = false;

		//^C}[ғԃtO
		bool timerWeightWorking = false;

		//^C}[ϓĎtO
		bool timerWeightChanged = false;

		//݂IDێϐ
		string  currentId = "0";
		
		//bZ[Wo̓tO
		bool messageEnabled = true;

		//VXeItO
		bool disposing = false;

	

		#endregion

		#region RXgN^/fXgN^
			
		public MainForm()
		{
			disposing = true;
			InitializeComponent();
			UpdateSetting(true);
			LoadUser();
			LoadWeightAll();
			UpdateCurrentId();
			disposing = false;
			StartConnect();
		}

		protected override void Dispose(bool disposing)
		{
			this.disposing = true;
			SaveUser();
			SaveWeightAll();

			UpdateSetting(false);
			StopConnect();
	
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}

			base.Dispose( disposing );
		}
		#endregion

		#region ID̃}b`OƃCxgJn/~

		private bool CheckMatchId(string id)
		{
			if(id == "0")
			{
				if(currentId != "0")
				{
					SetCurrentId("0");
					SetListViewColor("0");
					buttonRegister.Enabled = false;
				}
				return false;
			}
			else
			{
				if(userHolder.ContainsKey(id))
				{
					SetCurrentId(id);
					SetListViewColor(id);
					buttonRegister.Enabled = false;
					return true;
				}
				else
				{	
					SetCurrentId(id);
					SetListViewColor(id);
					buttonRegister.Enabled = true;
					return false;
				}
			}
		}

		public void SetCurrentId(string id)
		{
			currentId = id;
			if(!disposing)
			{
				this.textBoxId.Invoke(new EventHandler(TextBoxIdUpdate));
			}
		}

		void CheckTextBoxId()
		{
			buttonRegister.Enabled = false;
				
			if(textBoxId.Text != "")
			{
				try
				{
					//int dummy = int.Parse(textBoxId.Text);
					SetCurrentId(textBoxId.Text);	
				}
				catch(Exception ex)
				{
					PrintStatus(ex.Message);
					return;
				}

				if(!userHolder.Contains(textBoxId.Text))
				{
					buttonRegister.Enabled = true;
				}
			}
		}

		string GetIdByName(string name)
		{
			string result = null;
			foreach(User user in userHolder.Values)
			{
				if(user.name == name)
				{
					result = user.id;
					break;
				}
			}
			return result;
		}

		void UpdateCurrentId()
		{
			string id = GetIdByName(comboBoxUser.Text);
			if(id != null)
			{
				SetCurrentId(id);
			}
		}
		#endregion

		#region PhidgetServer̐ڑƃXbhJn/~
		//PhidgetServerɐڑ
		public bool Connect(IPAddress ip, int port)
		{
			try
			{
				IPEndPoint ipEndPoint = new IPEndPoint(ip, port);
				phidgetClient = new TcpClient();
				phidgetClient.Connect(ipEndPoint);
				phidgetClient.ReceiveTimeout = TIMEOUT_SERVER_RX;
				phidgetClient.SendTimeout = TIMEOUT_SERVER_TX;
				return true;
			}
			catch(Exception  ex)
			{
				PrintError(ex.Message);
				return false;
			}
		}

		//XbhJn
		private void StartThread()
		{
			if(rxThread == null)
			{
				rxThread = new Thread(new ThreadStart(RxWorker));
				rxThread.Start();
			}
		}

		//Xbh~
		private void StopThread()
		{
			if(rxThread != null)
			{
				rxThread.Abort();
				rxThread.Join();
				rxThread = null;
			}
			if(timerThread != null)
			{
				timerThread.Abort();
				timerThread = null;
			}
		}

		//AǂݎXbh
		private void RxWorker()
		{
			StreamReader reader = new StreamReader(phidgetClient.GetStream(),
														System.Text.Encoding.ASCII);

			try
			{
				while(true)
				{
					Thread.Sleep(rxThreadInterval);
					try
					{
						string line = reader.ReadLine();	
						PrintDebug(line);
						Parse(line);
					}
					catch(IOException ex)
					{
						continue;
					}
				}
			}
			catch(ThreadAbortException ex)
			{
				return;
			}
			catch(Exception ex)
			{
				PrintError(ex.ToString());
				return;
			}
		}

		//PhidgetServer̃bZ[W
		private bool Parse(string line)
		{
			bool result = false;
			string [] args = line.Split(",".ToCharArray());
				
			if(args[0] == "In")
			{
				if(args[1] == "RFID")
				{
					string id = args[2];
					CheckMatchId(id);
					result = true;
				}
				else if(args[1] == "Weight")
				{
					double weight = double.Parse(args[2]) + (double)numericUpDownOffset.Value;

					if(!weightRegistered)
						numericUpDownWeight.Value = (decimal)weight;

					if(weight < (double)numericUpDownWeightReset.Value)
					{
						ClearWeight();
					}
					else
					{
						if(!weightRegistered)
						{
							if(!timerWeightWorking)
							{
								StartTimer(weight);
							}
							else
							{
								UpdateTimer(weight);
							}
						}
					}
					result = true;
				}
			}
			return result;
		}

		//^C}[Jn
		void StartTimer(double weight)
		{
			timerWeightChanged = false;
			timerWeightWorking = true;
			currentWeight = weight;

			if(timerThread == null)
			{
				timerThread = new Thread(new ThreadStart(TimerWorker));
				timerThread.Start();
			}
		}

		//^C}[XVD̏dɈȏω΃^C}[ID
		void UpdateTimer(double weight)
		{
			double diff = Math.Abs(currentWeight - weight);
			if(diff > (double)numericUpDownWeightConfirmError.Value)
			{
				timerWeightChanged = true;
				currentWeight = weight;
				if(timerThread != null)
				{
					timerThread.Abort();
					timerThread = null;
				}
			}
		}

		//^C}[pXbh
		void TimerWorker()
		{
			try
			{
				while(true)
				{
					Thread.Sleep((int)numericUpDownWeightConfirmTime.Value * 1000);
					
					if(!timerWeightWorking)
					{
						break;
					}
					else if(!timerWeightChanged)
					{
						SetWeight(currentWeight);
						break;
					}
				}
			}
			catch(ThreadAbortException ex)
			{
			}
			catch(Exception ex)
			{
				PrintError(ex.Message);
			}
			finally
			{
				timerThread = null;
				timerWeightWorking = false;
			}
		}

		//̏dlm/ۑ
		void SetWeight(double weight)
		{
			foreach(User u in userHolder.Values)
			{	
				if(comboBoxUser.Text == u.name)
				{
					tabPageWeight.BackColor =Color.LightYellow;
					numericUpDownWeight.BackColor = Color.Gold;
					DateTime date = DateTime.Now;
					u.weightHolder.Add(date, weight);
					PrintStatus("o^: {0}, {1}", date.ToString(), weight);
					weightRegistered = true;	
					SaveWeight(u);
					this.Update();
					break;
				}
			}
		}

		//̏dlZbg
		void ClearWeight()
		{
			numericUpDownWeight.Value = (decimal)0.0;
			numericUpDownWeight.BackColor = NumericUpDown.DefaultBackColor;
			tabPageWeight.BackColor = TabPage.DefaultBackColor;
			PrintStatus("NA:");
			timerWeightWorking = false;
			weightRegistered = false;
			this.Update();
		}
	
		#endregion

		#region GUIR|[lg̏
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.textBoxId = new System.Windows.Forms.TextBox();
			this.labelId = new System.Windows.Forms.Label();
			this.labelRegistedId = new System.Windows.Forms.Label();
			this.buttonRegister = new System.Windows.Forms.Button();
			this.tabControl = new System.Windows.Forms.TabControl();
			this.tabPageWeight = new System.Windows.Forms.TabPage();
			this.groupBox4 = new System.Windows.Forms.GroupBox();
			this.buttonHistoryGraph = new System.Windows.Forms.Button();
			this.buttonHistoryList = new System.Windows.Forms.Button();
			this.numericUpDownWeight = new System.Windows.Forms.NumericUpDown();
			this.comboBoxUser = new System.Windows.Forms.ComboBox();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.tabPageId = new System.Windows.Forms.TabPage();
			this.listViewId = new System.Windows.Forms.ListView();
			this.columnHeaderId = new System.Windows.Forms.ColumnHeader();
			this.columnHeaderName = new System.Windows.Forms.ColumnHeader();
			this.tabPageSetting = new System.Windows.Forms.TabPage();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.label8 = new System.Windows.Forms.Label();
			this.numericUpDownOffset = new System.Windows.Forms.NumericUpDown();
			this.groupBox5 = new System.Windows.Forms.GroupBox();
			this.label9 = new System.Windows.Forms.Label();
			this.numericUpDownWeightReset = new System.Windows.Forms.NumericUpDown();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.label7 = new System.Windows.Forms.Label();
			this.numericUpDownWeightConfirmError = new System.Windows.Forms.NumericUpDown();
			this.label6 = new System.Windows.Forms.Label();
			this.numericUpDownWeightConfirmTime = new System.Windows.Forms.NumericUpDown();
			this.label4 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.groupBoxNet = new System.Windows.Forms.GroupBox();
			this.numericUpDownPort = new System.Windows.Forms.NumericUpDown();
			this.labelPort = new System.Windows.Forms.Label();
			this.labelIp = new System.Windows.Forms.Label();
			this.textBoxIp = new System.Windows.Forms.TextBox();
			this.buttonDisconnect = new System.Windows.Forms.Button();
			this.buttonConnect = new System.Windows.Forms.Button();
			this.tabPageDebug = new System.Windows.Forms.TabPage();
			this.checkBoxMessage = new System.Windows.Forms.CheckBox();
			this.textBoxMessage = new System.Windows.Forms.TextBox();
			this.statusBar = new System.Windows.Forms.StatusBar();
			this.tabControl.SuspendLayout();
			this.tabPageWeight.SuspendLayout();
			this.groupBox4.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownWeight)).BeginInit();
			this.tabPageId.SuspendLayout();
			this.tabPageSetting.SuspendLayout();
			this.groupBox1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownOffset)).BeginInit();
			this.groupBox5.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownWeightReset)).BeginInit();
			this.groupBox2.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownWeightConfirmError)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownWeightConfirmTime)).BeginInit();
			this.groupBoxNet.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownPort)).BeginInit();
			this.tabPageDebug.SuspendLayout();
			this.SuspendLayout();
			// 
			// textBoxId
			// 
			this.textBoxId.Location = new System.Drawing.Point(80, 16);
			this.textBoxId.Name = "textBoxId";
			this.textBoxId.Size = new System.Drawing.Size(120, 19);
			this.textBoxId.TabIndex = 8;
			this.textBoxId.Text = "";
			this.textBoxId.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxId_KeyDown);
			this.textBoxId.Leave += new System.EventHandler(this.textBoxId_Leave);
			// 
			// labelId
			// 
			this.labelId.Location = new System.Drawing.Point(8, 16);
			this.labelId.Name = "labelId";
			this.labelId.Size = new System.Drawing.Size(56, 16);
			this.labelId.TabIndex = 9;
			this.labelId.Text = "[UID:";
			// 
			// labelRegistedId
			// 
			this.labelRegistedId.Location = new System.Drawing.Point(8, 48);
			this.labelRegistedId.Name = "labelRegistedId";
			this.labelRegistedId.Size = new System.Drawing.Size(48, 16);
			this.labelRegistedId.TabIndex = 11;
			this.labelRegistedId.Text = "o^ID";
			// 
			// buttonRegister
			// 
			this.buttonRegister.Enabled = false;
			this.buttonRegister.Location = new System.Drawing.Point(208, 16);
			this.buttonRegister.Name = "buttonRegister";
			this.buttonRegister.Size = new System.Drawing.Size(72, 23);
			this.buttonRegister.TabIndex = 9;
			this.buttonRegister.Text = "IDo^";
			this.buttonRegister.Click += new System.EventHandler(this.buttonRegister_Click);
			// 
			// tabControl
			// 
			this.tabControl.Controls.Add(this.tabPageWeight);
			this.tabControl.Controls.Add(this.tabPageId);
			this.tabControl.Controls.Add(this.tabPageSetting);
			this.tabControl.Controls.Add(this.tabPageDebug);
			this.tabControl.Location = new System.Drawing.Point(0, 8);
			this.tabControl.Name = "tabControl";
			this.tabControl.SelectedIndex = 0;
			this.tabControl.Size = new System.Drawing.Size(296, 200);
			this.tabControl.TabIndex = 8;
			// 
			// tabPageWeight
			// 
			this.tabPageWeight.Controls.Add(this.groupBox4);
			this.tabPageWeight.Controls.Add(this.numericUpDownWeight);
			this.tabPageWeight.Controls.Add(this.comboBoxUser);
			this.tabPageWeight.Controls.Add(this.label3);
			this.tabPageWeight.Controls.Add(this.label2);
			this.tabPageWeight.Controls.Add(this.label1);
			this.tabPageWeight.Location = new System.Drawing.Point(4, 21);
			this.tabPageWeight.Name = "tabPageWeight";
			this.tabPageWeight.Size = new System.Drawing.Size(288, 175);
			this.tabPageWeight.TabIndex = 3;
			this.tabPageWeight.Text = "̏dv";
			// 
			// groupBox4
			// 
			this.groupBox4.Controls.Add(this.buttonHistoryGraph);
			this.groupBox4.Controls.Add(this.buttonHistoryList);
			this.groupBox4.Location = new System.Drawing.Point(64, 112);
			this.groupBox4.Name = "groupBox4";
			this.groupBox4.Size = new System.Drawing.Size(144, 48);
			this.groupBox4.TabIndex = 8;
			this.groupBox4.TabStop = false;
			this.groupBox4.Text = "";
			// 
			// buttonHistoryGraph
			// 
			this.buttonHistoryGraph.Location = new System.Drawing.Point(80, 16);
			this.buttonHistoryGraph.Name = "buttonHistoryGraph";
			this.buttonHistoryGraph.Size = new System.Drawing.Size(56, 23);
			this.buttonHistoryGraph.TabIndex = 7;
			this.buttonHistoryGraph.Text = "Ot";
			this.buttonHistoryGraph.Click += new System.EventHandler(this.buttonHistoryView_Click);
			// 
			// buttonHistoryList
			// 
			this.buttonHistoryList.Location = new System.Drawing.Point(8, 16);
			this.buttonHistoryList.Name = "buttonHistoryList";
			this.buttonHistoryList.Size = new System.Drawing.Size(56, 23);
			this.buttonHistoryList.TabIndex = 9;
			this.buttonHistoryList.Text = "Xg";
			this.buttonHistoryList.Click += new System.EventHandler(this.buttonHistoryList_Click);
			// 
			// numericUpDownWeight
			// 
			this.numericUpDownWeight.DecimalPlaces = 1;
			this.numericUpDownWeight.Font = new System.Drawing.Font("MS UI Gothic", 32F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.numericUpDownWeight.Location = new System.Drawing.Point(72, 48);
			this.numericUpDownWeight.Maximum = new System.Decimal(new int[] {
																				136,
																				0,
																				0,
																				0});
			this.numericUpDownWeight.Minimum = new System.Decimal(new int[] {
																				5,
																				0,
																				0,
																				-2147483648});
			this.numericUpDownWeight.Name = "numericUpDownWeight";
			this.numericUpDownWeight.Size = new System.Drawing.Size(136, 50);
			this.numericUpDownWeight.TabIndex = 6;
			// 
			// comboBoxUser
			// 
			this.comboBoxUser.Location = new System.Drawing.Point(72, 16);
			this.comboBoxUser.Name = "comboBoxUser";
			this.comboBoxUser.Size = new System.Drawing.Size(121, 20);
			this.comboBoxUser.TabIndex = 5;
			this.comboBoxUser.SelectedIndexChanged += new System.EventHandler(this.comboBoxUser_SelectedIndexChanged);
			// 
			// label3
			// 
			this.label3.Font = new System.Drawing.Font("MS UI Gothic", 24F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.label3.Location = new System.Drawing.Point(224, 64);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(48, 32);
			this.label3.TabIndex = 4;
			this.label3.Text = "kg";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 48);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(40, 16);
			this.label2.TabIndex = 2;
			this.label2.Text = "̏d:";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(40, 16);
			this.label1.TabIndex = 0;
			this.label1.Text = "[U:";
			// 
			// tabPageId
			// 
			this.tabPageId.Controls.Add(this.listViewId);
			this.tabPageId.Controls.Add(this.textBoxId);
			this.tabPageId.Controls.Add(this.labelId);
			this.tabPageId.Controls.Add(this.buttonRegister);
			this.tabPageId.Controls.Add(this.labelRegistedId);
			this.tabPageId.Location = new System.Drawing.Point(4, 21);
			this.tabPageId.Name = "tabPageId";
			this.tabPageId.Size = new System.Drawing.Size(288, 175);
			this.tabPageId.TabIndex = 1;
			this.tabPageId.Text = "IDǗ";
			// 
			// listViewId
			// 
			this.listViewId.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						 this.columnHeaderId,
																						 this.columnHeaderName});
			this.listViewId.GridLines = true;
			this.listViewId.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.listViewId.Location = new System.Drawing.Point(8, 72);
			this.listViewId.MultiSelect = false;
			this.listViewId.Name = "listViewId";
			this.listViewId.Size = new System.Drawing.Size(288, 96);
			this.listViewId.Sorting = System.Windows.Forms.SortOrder.Ascending;
			this.listViewId.TabIndex = 16;
			this.listViewId.View = System.Windows.Forms.View.Details;
			this.listViewId.KeyDown += new System.Windows.Forms.KeyEventHandler(this.listViewId_KeyDown);
			this.listViewId.DoubleClick += new System.EventHandler(this.listViewId_DoubleClick);
			// 
			// columnHeaderId
			// 
			this.columnHeaderId.Text = "ID";
			this.columnHeaderId.Width = 120;
			// 
			// columnHeaderName
			// 
			this.columnHeaderName.Text = "Name";
			this.columnHeaderName.Width = 140;
			// 
			// tabPageSetting
			// 
			this.tabPageSetting.Controls.Add(this.groupBox1);
			this.tabPageSetting.Controls.Add(this.groupBox5);
			this.tabPageSetting.Controls.Add(this.groupBox2);
			this.tabPageSetting.Controls.Add(this.groupBoxNet);
			this.tabPageSetting.Location = new System.Drawing.Point(4, 21);
			this.tabPageSetting.Name = "tabPageSetting";
			this.tabPageSetting.Size = new System.Drawing.Size(288, 175);
			this.tabPageSetting.TabIndex = 4;
			this.tabPageSetting.Text = "ݒ";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.label8);
			this.groupBox1.Controls.Add(this.numericUpDownOffset);
			this.groupBox1.Location = new System.Drawing.Point(144, 128);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(136, 40);
			this.groupBox1.TabIndex = 20;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "ItZbg";
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(80, 16);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(48, 16);
			this.label8.TabIndex = 6;
			this.label8.Text = "kg";
			// 
			// numericUpDownOffset
			// 
			this.numericUpDownOffset.DecimalPlaces = 1;
			this.numericUpDownOffset.Location = new System.Drawing.Point(32, 16);
			this.numericUpDownOffset.Minimum = new System.Decimal(new int[] {
																				100,
																				0,
																				0,
																				-2147483648});
			this.numericUpDownOffset.Name = "numericUpDownOffset";
			this.numericUpDownOffset.Size = new System.Drawing.Size(48, 19);
			this.numericUpDownOffset.TabIndex = 5;
			// 
			// groupBox5
			// 
			this.groupBox5.Controls.Add(this.label9);
			this.groupBox5.Controls.Add(this.numericUpDownWeightReset);
			this.groupBox5.Location = new System.Drawing.Point(144, 88);
			this.groupBox5.Name = "groupBox5";
			this.groupBox5.Size = new System.Drawing.Size(136, 40);
			this.groupBox5.TabIndex = 8;
			this.groupBox5.TabStop = false;
			this.groupBox5.Text = "̏dZbg";
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(80, 16);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(48, 16);
			this.label9.TabIndex = 6;
			this.label9.Text = "kgȉ";
			// 
			// numericUpDownWeightReset
			// 
			this.numericUpDownWeightReset.DecimalPlaces = 1;
			this.numericUpDownWeightReset.Location = new System.Drawing.Point(32, 16);
			this.numericUpDownWeightReset.Name = "numericUpDownWeightReset";
			this.numericUpDownWeightReset.Size = new System.Drawing.Size(48, 19);
			this.numericUpDownWeightReset.TabIndex = 5;
			this.numericUpDownWeightReset.Value = new System.Decimal(new int[] {
																				   1,
																				   0,
																				   0,
																				   0});
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.label7);
			this.groupBox2.Controls.Add(this.numericUpDownWeightConfirmError);
			this.groupBox2.Controls.Add(this.label6);
			this.groupBox2.Controls.Add(this.numericUpDownWeightConfirmTime);
			this.groupBox2.Controls.Add(this.label4);
			this.groupBox2.Controls.Add(this.label5);
			this.groupBox2.Location = new System.Drawing.Point(8, 88);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(136, 80);
			this.groupBox2.TabIndex = 6;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "̏dm";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(8, 56);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(56, 16);
			this.label7.TabIndex = 3;
			this.label7.Text = "e덷:";
			// 
			// numericUpDownWeightConfirmError
			// 
			this.numericUpDownWeightConfirmError.DecimalPlaces = 1;
			this.numericUpDownWeightConfirmError.Location = new System.Drawing.Point(64, 56);
			this.numericUpDownWeightConfirmError.Name = "numericUpDownWeightConfirmError";
			this.numericUpDownWeightConfirmError.Size = new System.Drawing.Size(48, 19);
			this.numericUpDownWeightConfirmError.TabIndex = 4;
			this.numericUpDownWeightConfirmError.Value = new System.Decimal(new int[] {
																						  1,
																						  0,
																						  0,
																						  0});
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(112, 56);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(16, 16);
			this.label6.TabIndex = 5;
			this.label6.Text = "kg";
			// 
			// numericUpDownWeightConfirmTime
			// 
			this.numericUpDownWeightConfirmTime.Location = new System.Drawing.Point(64, 24);
			this.numericUpDownWeightConfirmTime.Name = "numericUpDownWeightConfirmTime";
			this.numericUpDownWeightConfirmTime.Size = new System.Drawing.Size(48, 19);
			this.numericUpDownWeightConfirmTime.TabIndex = 1;
			this.numericUpDownWeightConfirmTime.Value = new System.Decimal(new int[] {
																						 3,
																						 0,
																						 0,
																						 0});
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(8, 24);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(56, 16);
			this.label4.TabIndex = 0;
			this.label4.Text = "ҋ@:";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(112, 24);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(16, 16);
			this.label5.TabIndex = 2;
			this.label5.Text = "b";
			// 
			// groupBoxNet
			// 
			this.groupBoxNet.Controls.Add(this.numericUpDownPort);
			this.groupBoxNet.Controls.Add(this.labelPort);
			this.groupBoxNet.Controls.Add(this.labelIp);
			this.groupBoxNet.Controls.Add(this.textBoxIp);
			this.groupBoxNet.Controls.Add(this.buttonDisconnect);
			this.groupBoxNet.Controls.Add(this.buttonConnect);
			this.groupBoxNet.Location = new System.Drawing.Point(8, 0);
			this.groupBoxNet.Name = "groupBoxNet";
			this.groupBoxNet.Size = new System.Drawing.Size(272, 80);
			this.groupBoxNet.TabIndex = 19;
			this.groupBoxNet.TabStop = false;
			this.groupBoxNet.Text = "PhidgetServer";
			// 
			// numericUpDownPort
			// 
			this.numericUpDownPort.Location = new System.Drawing.Point(56, 56);
			this.numericUpDownPort.Maximum = new System.Decimal(new int[] {
																			  100000,
																			  0,
																			  0,
																			  0});
			this.numericUpDownPort.Name = "numericUpDownPort";
			this.numericUpDownPort.Size = new System.Drawing.Size(56, 19);
			this.numericUpDownPort.TabIndex = 16;
			this.numericUpDownPort.Value = new System.Decimal(new int[] {
																			4321,
																			0,
																			0,
																			0});
			// 
			// labelPort
			// 
			this.labelPort.Location = new System.Drawing.Point(8, 56);
			this.labelPort.Name = "labelPort";
			this.labelPort.Size = new System.Drawing.Size(40, 16);
			this.labelPort.TabIndex = 15;
			this.labelPort.Text = "|[g:";
			// 
			// labelIp
			// 
			this.labelIp.Location = new System.Drawing.Point(16, 24);
			this.labelIp.Name = "labelIp";
			this.labelIp.Size = new System.Drawing.Size(24, 16);
			this.labelIp.TabIndex = 14;
			this.labelIp.Text = "IP:";
			// 
			// textBoxIp
			// 
			this.textBoxIp.Location = new System.Drawing.Point(56, 24);
			this.textBoxIp.Name = "textBoxIp";
			this.textBoxIp.Size = new System.Drawing.Size(80, 19);
			this.textBoxIp.TabIndex = 13;
			this.textBoxIp.Text = "127.0.0.1";
			// 
			// buttonDisconnect
			// 
			this.buttonDisconnect.Enabled = false;
			this.buttonDisconnect.Location = new System.Drawing.Point(208, 24);
			this.buttonDisconnect.Name = "buttonDisconnect";
			this.buttonDisconnect.Size = new System.Drawing.Size(56, 23);
			this.buttonDisconnect.TabIndex = 18;
			this.buttonDisconnect.Text = "ؒf";
			this.buttonDisconnect.Click += new System.EventHandler(this.buttonDisconnect_Click);
			// 
			// buttonConnect
			// 
			this.buttonConnect.Location = new System.Drawing.Point(144, 24);
			this.buttonConnect.Name = "buttonConnect";
			this.buttonConnect.Size = new System.Drawing.Size(56, 23);
			this.buttonConnect.TabIndex = 17;
			this.buttonConnect.Text = "ڑ";
			this.buttonConnect.Click += new System.EventHandler(this.buttonConnect_Click);
			// 
			// tabPageDebug
			// 
			this.tabPageDebug.Controls.Add(this.checkBoxMessage);
			this.tabPageDebug.Controls.Add(this.textBoxMessage);
			this.tabPageDebug.Location = new System.Drawing.Point(4, 21);
			this.tabPageDebug.Name = "tabPageDebug";
			this.tabPageDebug.Size = new System.Drawing.Size(288, 175);
			this.tabPageDebug.TabIndex = 2;
			this.tabPageDebug.Text = "fobO";
			// 
			// checkBoxMessage
			// 
			this.checkBoxMessage.Checked = true;
			this.checkBoxMessage.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkBoxMessage.Location = new System.Drawing.Point(16, 8);
			this.checkBoxMessage.Name = "checkBoxMessage";
			this.checkBoxMessage.Size = new System.Drawing.Size(168, 24);
			this.checkBoxMessage.TabIndex = 3;
			this.checkBoxMessage.Text = "fobObZ[W\";
			this.checkBoxMessage.CheckedChanged += new System.EventHandler(this.checkBoxMessage_CheckedChanged);
			// 
			// textBoxMessage
			// 
			this.textBoxMessage.Location = new System.Drawing.Point(8, 32);
			this.textBoxMessage.Multiline = true;
			this.textBoxMessage.Name = "textBoxMessage";
			this.textBoxMessage.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.textBoxMessage.Size = new System.Drawing.Size(280, 120);
			this.textBoxMessage.TabIndex = 2;
			this.textBoxMessage.Text = "";
			// 
			// statusBar
			// 
			this.statusBar.Location = new System.Drawing.Point(0, 210);
			this.statusBar.Name = "statusBar";
			this.statusBar.Size = new System.Drawing.Size(298, 22);
			this.statusBar.SizingGrip = false;
			this.statusBar.TabIndex = 14;
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(298, 232);
			this.Controls.Add(this.statusBar);
			this.Controls.Add(this.tabControl);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "MainForm";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
			this.Text = "PhidgetHealth";
			this.tabControl.ResumeLayout(false);
			this.tabPageWeight.ResumeLayout(false);
			this.groupBox4.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownWeight)).EndInit();
			this.tabPageId.ResumeLayout(false);
			this.tabPageSetting.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownOffset)).EndInit();
			this.groupBox5.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownWeightReset)).EndInit();
			this.groupBox2.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownWeightConfirmError)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownWeightConfirmTime)).EndInit();
			this.groupBoxNet.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownPort)).EndInit();
			this.tabPageDebug.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region bZ[W֘Ã\bh

		public void PrintStatus(string m, params object []args)
		{
			statusBar.Text =  String.Format(m,args);
		}

		public void PrintMessage(string m, params object []args)
		{
			
			if(textBoxMessage.TextLength > TEXTBOX_CNT_MAX)
				textBoxMessage.Clear();

			textBoxMessage.Text = String.Format(m,args) + "\r\n" + textBoxMessage.Text;				
		}

		public void PrintError(string m, params object []args)
		{
			PrintMessage("Error: " + m,args);
		}

		public void PrintDebug(string m, params object []args)
		{
			if(messageEnabled)
			{
				PrintMessage(m,args);
			}
		}

		#endregion

		#region GUIR|[lg̃Cxg

		//UIR|[lg̍XV
		private void TextBoxIdUpdate(object sender, EventArgs e)
		{
			lock(this)
			{
				if(currentId == "0")
					textBoxId.Text = "No Card";
				else
					textBoxId.Text = currentId.ToString();
			}
			this.textBoxId.Update();
		}
	
		//ݔFĂJ[hIDnbV/Xg{bNXɓo^D
		private void buttonRegister_Click(object sender, System.EventArgs e)
		{
			string idStr = currentId.ToString();

			bool existFlag = false;
			foreach(ListViewItem item in listViewId.Items)
			{
				if(item.SubItems[0].Text == idStr)
				{
					existFlag = true;
					break;
				}
			}

			if(existFlag)
			{
				string m = "Error: ID͊ɓo^ς݂łD";
				PrintMessage(m);
				PrintStatus(m);
			}
			else
			{
				string id = idStr;
				string m = "IDo^܂D";
				PrintMessage(m);
				PrintStatus(m);

				if(!userHolder.ContainsKey(id))
				{
					User user = new User(id, "",0,User.Sexes.Man);
					userHolder.Add(id, user);
				}

				if(listViewId.Items.Count == 1 && (string)listViewId.Items[0].SubItems[0].Text == "")
				{
					string []subItems = {idStr, ""};
					listViewId.Items[0] = new ListViewItem(subItems);
				}
				else
				{
					string []subItems = {idStr, ""};
					listViewId.Items.Add(new ListViewItem(subItems));
				}
			}
		}

		private void listViewId_DoubleClick(object sender, System.EventArgs e)
		{
			if(listViewId.SelectedItems.Count == 0)
			{
				return;
			}

			string id = listViewId.SelectedItems[0].SubItems[0].Text;
			User user = null;

			if(userHolder.ContainsKey(id))
			{
				user = (User)userHolder[id];
			}
			else
			{
				user = new User(id,"",0,(User.Sexes)0);
			}

			UserForm form = new UserForm(user);
			DialogResult result = form.ShowDialog(this);

			if(result == DialogResult.OK)
			{
				if(userHolder.ContainsKey(id))
				{
					userHolder[id] = user;
				}
				else
				{
					userHolder.Add(id, user);
				}

				listViewId.SelectedItems[0].SubItems[1].Text = user.name.ToString();
				comboBoxUser.Items.Add(user.name);
			}
			form.Dispose();
			buttonRegister.Enabled = false;
			SaveUser();
		}

		private void listViewId_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if(e.KeyCode ==Keys.Delete)
			{
				int index = listViewId.SelectedIndices[0];
				string id = (string)listViewId.Items[index].SubItems[0].Text;
				if(listViewId.Items[index] != null)
				{
					foreach(string s in comboBoxUser.Items)
					{
						if(s == ((User)userHolder[id]).name)
						{
							comboBoxUser.Items.Remove(s);
							break;
						}
					}

					if(userHolder.Contains(id))
					{
						userHolder.Remove(id);
					}
					listViewId.Items.RemoveAt(index);

					SaveUser();
				}
			}
		}

		private void SetListViewColor(string id)
		{
			foreach(ListViewItem li in listViewId.Items)
			{
				if(id == "0")
				{
					li.ForeColor = Color.Black;
				}
				else
				{
					if(li.SubItems[0].Text == id.ToString())
					{
						li.ForeColor = Color.Red;
					}
				}
			}
			return;
		}

		private void buttonConnect_Click(object sender, System.EventArgs e)
		{
			StartConnect();
		}

		private void buttonDisconnect_Click(object sender, System.EventArgs e)
		{
			StopConnect();
		}

		private void StartConnect()
		{
			if(!Connect(IPAddress.Parse(textBoxIp.Text), (int)numericUpDownPort.Value))
				return;
		
			string m = String.Format("PhidgetServerɐڑ܂.[{0}:{1}]", 
				textBoxIp.Text, numericUpDownPort.Value.ToString());
			
			if(!disposing)
			{
				PrintStatus(m);
				PrintMessage(m);

				tabControl.SelectedTab = tabPageWeight;

				StartThread();
				buttonConnect.Enabled = false;
				buttonDisconnect.Enabled = true;
			}
		}

		private void StopConnect()
		{
			StopThread();
			if(phidgetClient!=null)
				phidgetClient.Close();
			
			if(!disposing)
			{
				string m = String.Format("PhidgetServerؒf܂");
				PrintStatus(m);
				PrintMessage(m);

				tabControl.SelectedTab = tabPageSetting;

				buttonConnect.Enabled = true;
				buttonDisconnect.Enabled = false;
			}
		}

		private void checkBoxMessage_CheckedChanged(object sender, System.EventArgs e)
		{
			messageEnabled = checkBoxMessage.Checked;
		}

		private void textBoxId_Leave(object sender, System.EventArgs e)
		{
			CheckTextBoxId();
		}

		private void textBoxId_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if(e.KeyCode == Keys.Enter)
				CheckTextBoxId();
		}

		private void buttonHistoryList_Click(object sender, System.EventArgs e)
		{
			ListForm form = new ListForm((User)userHolder[currentId]);
			form.ShowDialog(this);
			userHolder[currentId] = form.user;
			SaveWeight((User)userHolder[currentId]);
		}

		private void buttonHistoryView_Click(object sender, System.EventArgs e)
		{
			//HistoryForm form = new HistoryForm((User)userHolder[currentId]);
			//form.ShowDialog(this);
			HistoryPhotoForm form = new HistoryPhotoForm((User)userHolder[currentId]);
			form.ShowDialog(this);		
		}

		private void comboBoxUser_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			UpdateCurrentId();
		}


		#endregion

		#region Save/Load̏
		//ݒt@C̕ۑ/Ǎ
		private void UpdateSetting(bool componentUpdate)
		{
			Setting setting = new Setting(SETTING_FILE);
			if(!componentUpdate)
			{
				setting.Set(textBoxIp.Name, textBoxIp.Text);
				setting.Set(numericUpDownPort.Name, numericUpDownPort.Value.ToString());
				setting.Set(numericUpDownWeightConfirmTime.Name, numericUpDownWeightConfirmTime.Value.ToString());
				setting.Set(numericUpDownWeightConfirmError.Name, numericUpDownWeightConfirmError.Value.ToString());
				setting.Set(numericUpDownOffset.Name, numericUpDownOffset.Value.ToString());
				setting.Set(checkBoxMessage.Name,checkBoxMessage.Checked.ToString());
				if(comboBoxUser.SelectedItem != null)
				{
					setting.Set(comboBoxUser.Name, GetIdByName(comboBoxUser.SelectedItem.ToString()));
				}
				setting.Save();
			}
			else
			{
				setting.Load();
				string data = "";
				setting.Get(textBoxIp.Name, ref data);
				if(data != "")
					textBoxIp.Text = data;

				data = "";
				setting.Get(numericUpDownPort.Name, ref data);
				if(data != "")
					numericUpDownPort.Value = decimal.Parse(data);

				data = "";
				setting.Get(numericUpDownWeightConfirmTime.Name, ref data);
				if(data != "")
					numericUpDownWeightConfirmTime.Value = decimal.Parse(data);
		
				data = "";
				setting.Get(numericUpDownWeightConfirmError.Name, ref data);
				if(data != "")
					numericUpDownWeightConfirmError.Value = decimal.Parse(data);

				data = "";
				setting.Get(numericUpDownOffset.Name, ref data);
				if(data != "")
					numericUpDownOffset.Value = decimal.Parse(data);
		
				data = "";
				setting.Get(checkBoxMessage.Name, ref data);
				if(data != "")
					checkBoxMessage.Checked = bool.Parse(data);
	
				data = "";
				setting.Get(comboBoxUser.Name, ref data);
				if(data != "")
					currentId = data;
			}
			return;
		}

		//o^ꂽUsert@CɕۑD
		private void SaveUser()
		{	
			StreamWriter writer = new StreamWriter(Application.StartupPath + @"\" + USER_FILE, false);

			try
			{
				foreach(User user in userHolder.Values)
				{
					string message = string.Format("{1}{0}{2}{0}{3}{0}{4}", 
						DELIMITER, user.id, user.name, user.height, (int)user.sex);	
					writer.WriteLine(message);		
				}
			}
			catch(Exception ex)
			{
				PrintError(ex.ToString());
			}
			finally
			{
				writer.Close();
			}
		}
		
		//t@Co^ꂽACe[hCnbVɉDD
		private void LoadUser()
		{
			string userFile = Application.StartupPath + @"\" + USER_FILE;

			if(!File.Exists(userFile))
				return;

			StreamReader reader = new StreamReader(userFile);
			try
			{
				while(true)
				{
					string line = reader.ReadLine();
					
					if(line == null) 
						break;

					string [] args = line.Split(DELIMITER.ToCharArray());
					
					if(args.Length < 4)
						continue;

					User u = new User(args[0], args[1], 
						double.Parse(args[2]),(User.Sexes)int.Parse(args[3]));
					
					userHolder.Add(u.id, u);

					if(listViewId.Items.Count == 1 && (string)listViewId.Items[0].SubItems[0].Text == "")
					{
						string []subItems = {u.id.ToString(), ""};
						listViewId.Items[0] = new ListViewItem(subItems);
					}
					else
					{
						string []subItems = {u.id.ToString(), u.name.ToString()};
						listViewId.Items.Add(new ListViewItem(subItems));
					}

					comboBoxUser.Items.Add(u.name);						
				}
			}
			catch(Exception ex)
			{
				PrintError(ex.ToString());
			}
			finally
			{
				if(userHolder.Contains(currentId))
					comboBoxUser.Text = ((User)userHolder[currentId]).name;
	
				reader.Close();
			}
		}

		private void SaveWeight(User user)
		{	

			string file = "";
			StreamWriter writer = null;
			try
			{
				file = Application.StartupPath + @"\data\" + user.id + ".txt";
				writer = new StreamWriter(file, false);

				foreach(DateTime key in user.weightHolder.Keys)
				{
					double val = user.Get(key);
					string message = string.Format("{1}{0}{2}", DELIMITER, key.ToString(), 
						val.ToString());	
					writer.WriteLine(message);	
				}
			}
			catch(Exception ex)
			{
				PrintError(ex.ToString());
			}
			finally
			{
				if(writer!=null)
					writer.Close();
			}
		}

		private void SaveWeightAll()
		{
			foreach(User user in userHolder.Values)
			{
				SaveWeight(user);
			}
		}
		
		private void LoadWeight(User user)
		{	
			string file = "";
			StreamReader reader = null;
			try
			{
				file = Application.StartupPath + @"\data\" + user.id + ".txt";

				if(!File.Exists(file))
					return;

				reader = new StreamReader(file);

				while(true)
				{
					string line = reader.ReadLine();
						
					if(line ==null)
						break;

					string [] args = line.Split(DELIMITER.ToCharArray()); 
						
					if(args.Length < 2)
						continue;

					user.weightHolder.Add(DateTime.Parse(args[0]), double.Parse(args[1]));	
				}
			}
			catch(Exception ex)
			{
				PrintError(ex.ToString());
			}
			finally
			{
				if(reader != null)
					reader.Close();
			}
			
		}

		void LoadWeightAll()
		{
			foreach(User user in userHolder.Values)
			{
				LoadWeight(user);
			}
		}

		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}
	}
}
